Bug 894524

Summary: Review Request: rubygem-openshift-origin-console - OpenShift Origin Management Console
Product: [Fedora] Fedora Reporter: Troy Dawson <tdawson>
Component: Package ReviewAssignee: Michael Scherer <misc>
Status: CLOSED DEFERRED QA Contact: Fedora Extras Quality Assurance <extras-qa>
Severity: medium Docs Contact:
Priority: medium    
Version: rawhideCC: axilleas, mgoldman, misc, mmahut, tdawson, vondruch
Target Milestone: ---   
Target Release: ---   
Hardware: All   
OS: Linux   
Whiteboard:
Fixed In Version: Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of: Environment:
Last Closed: 2014-10-03 13:48:54 EDT Type: ---
Regression: --- Mount Type: ---
Documentation: --- CRM:
Verified Versions: Category: ---
oVirt Team: --- RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---
Bug Depends On: 988890    
Bug Blocks: 908116    

Description Troy Dawson 2013-01-11 18:36:47 EST
Spec URL: http://tdawson.fedorapeople.org/openshift-origin/rubygem-openshift-origin-console.spec
SRPM URL: http://tdawson.fedorapeople.org/openshift-origin/rubygem-openshift-origin-console-1.2.9-2.fc18.src.rpm
Description: This contains the OpenShift Origin Management Console.
Fedora Account System Username: tdawson maxamillion
Comment 1 Troy Dawson 2013-01-11 18:37:29 EST
rpmlint output:

$ rpmlint rubygem-openshift-origin-console.spec /home/quake/rpmbuild/SRPMS/rubygem-openshift-origin-console-1.2.9-2.fc18.src.rpm /home/quake/rpmbuild/RPMS/noarch/rubygem-openshift-origin-console-1.2.9-2.fc18.noarch.rpm /home/quake/rpmbuild/RPMS/noarch/rubygem-openshift-origin-console-doc-1.2.9-2.fc18.noarch.rpm
3 packages and 1 specfiles checked; 0 errors, 0 warnings.
Comment 2 Michael Scherer 2013-02-23 12:25:21 EST
Hi,a few notes 

- why do you put the deps between %if 0%{?fedora}%{?rhel} <= 6 ( as I think they will not be submitted to RHEL5 ?

- package doesn't build it seems :


+ chmod 755 '/builddir/build/BUILDROOT/rubygem-openshift-origin-console-1.2.9-2.fc19.x86_64/%{gem_instdir}/Rakefile'
chmod: cannot access '/builddir/build/BUILDROOT/rubygem-openshift-origin-console-1.2.9-2.fc19.x86_64/%{gem_instdir}/Rakefile': No such file or directory
erreur : Mauvais statut de sortie pour /var/tmp/rpm-tmp.WSNiH2 (%install)
Erreur de construction de RPM :
    Mauvais statut de sortie pour /var/tmp/rpm-tmp.WSNiH2 (%install)
Child return code was: 1

missing requires for the macros ?
Comment 3 Troy Dawson 2013-02-27 12:28:43 EST
Spec URL: http://tdawson.fedorapeople.org/openshift-origin/rubygem-openshift-origin-console.spec
SRPM URL: http://tdawson.fedorapeople.org/openshift-origin/rubygem-openshift-origin-console-1.4.9-3.fc18.src.rpm

- Updated to the latest stable release
-- This fixed the missing rubygems-devel issue, the reason behind the macro's not being installed.

- Removed the top lines
%if 0%{?fedora}%{?rhel} <= 6
    %global scl ruby193
    %global scl_prefix ruby193-
%endif
-- This is in response to a discussion with Vit on a different openshift origin rubygem.

- Removed everything in the %if 0%{?fedora}%{?rhel} <= 6 section.  We do not plan on this going into EPEL 5 or 6, so it isn't needed.
-- I will talk to upstream about taking this out, because it doesn't make sense.  Why would RHEL has such drastically different dependencies than Fedora.  I think it is just leftover from some testing.
Comment 5 Michael Scherer 2013-03-24 16:12:29 EDT
-doc package either need to requires the main package, or it need to ship the license file.

in %build, there is another "%if 0%{?fedora}%{?rhel} <= 6", since this shouldn't go to EL 5, that's either dead code, or a error.
Comment 7 Vít Ondruch 2013-03-27 04:28:37 EDT
(In reply to comment #5)
> -doc package either need to requires the main package, or it need to ship
> the license file.

Actually it already requires the main package and that is the only possibility in this case. Not because of the license, but because of the doc folder ownership.

BTW, Troy,

* there is %{gem_docdir} macro which you should use instead of %{gem_dir}/doc/%{gem_name}-%{version} and it should be marked as a %doc

* %doc %{gem_instdir}/Gemfile in contrary should not be marked as a doc, since it is obviously not documentation.

* What is the content of %{gem_instdir}/vendor ? Even the name is scary and suggest some bundling, which is prohibited on Fedora [1]. I admit that I did not checked what is inside, though

* I would appreciate if you can run some test suite, if feasible.

* You should be using %gem_install macro [2] (especially because your install command does not generate RDoc documentation, which we used to have available on Fedora.


[1] https://fedoraproject.org/wiki/Packaging:Guidelines#Duplication_of_system_libraries
[2] https://fedorahosted.org/fpc/ticket/256
Comment 8 Troy Dawson 2013-06-13 17:52:00 EDT
Spec URL: http://tdawson.fedorapeople.org/openshift-origin/rubygem-openshift-origin-console.spec
SRPM URL: http://tdawson.fedorapeople.org/openshift-origin/rubygem-openshift-origin-console-1.9.13-1.fc20.src.rpm

- Updated to latest stable release
- Use %{gem_docdir} macro, mark as %doc
- Use %gem_install macro
- Remove %doc from %{gem_instdir}/Gemfile
- Test suite still requires infrastructure to be setup.
-- Talking with upstream
- %{gem_instdir}/vendor
-- I initially thought this was just poor naming of a directory that had javascripts and stylesheets for Onpenshift Online.  It still sorta looks that way, but the copyrights at the top of the files don't add up.
-- Working with upstream to determine what's up with this directory.
Comment 9 Vít Ondruch 2013-06-14 10:08:44 EDT
* %{gem_instdir} ownership
  - Please add "%dir %{gem_instdir}" to own the gem direcotory, which is not
    owned now

* noarch -doc subpackage
  - -doc subpackage should be noarch

* exclude %{gem_cache}
  - We are typically excluding %{gem_cache}, since it has no purpose on Fedora.

It seems that this is still WIP, due to the vendor directory. Its content looks to be Twitter's Bootstrap. BTW, there is ongoing review of rubygem-bootstrap-sass [1] if that might be of any relevance.


[1] https://bugzilla.redhat.com/show_bug.cgi?id=920436
Comment 10 Troy Dawson 2013-06-14 15:56:05 EDT
Spec URL: http://tdawson.fedorapeople.org/openshift-origin/rubygem-openshift-origin-console.spec
SRPM URL: http://tdawson.fedorapeople.org/openshift-origin/rubygem-openshift-origin-console-1.9.13-2.fc20.src.rpm

- Added %dir %{gem_instdir}
- Made -doc subpackage noarch
- Excluded %{gem_cache}
- Removed %{gem_instdir}/vendor and added Requires: rubygem(bootstrap-sass)
-- Upstream confirmed that they have the bootstrap-sass gem in that directory
-- They indicated that we *should* be able to remove the directory as long as we have that gem ... but that it has not been tested.
-- due to the lack of test scripts, this is harder to do that I wish.
-- I think this review should be put on hold until this is tested.
Comment 11 Troy Dawson 2013-07-17 12:08:05 EDT
I found out from Upstream that they have a fork of sass-twitter-bootstrap in vendor, and not bootstrap-sass.
They are working on unbundling that into it's own gem.
When that gem is ready, I will start it's review and mark this as a dependancy on that package.  Until that time, we'll keep this on hold.
Comment 12 Troy Dawson 2013-08-20 18:37:37 EDT
Spec URL: http://tdawson.fedorapeople.org/openshift-origin/rubygem-openshift-origin-console.spec
SRPM URL: http://tdawson.fedorapeople.org/openshift-origin/rubygem-openshift-origin-console-1.13.0.1-1.fc20.src.rpm

- Updated to latest upstream stable version
-- They removed the saas-twitter-boostrap from the vendor directory.  It is now a requirement, and no longer in the rpm.
Comment 13 Michael Scherer 2013-10-19 07:10:22 EDT
I see that bootstrap is still in the rpm, bundled, see

/usr/share/gems/gems/openshift-origin-console-1.13.0.1/app/assets/javascripts/console/bootstrap-collapse.js

Not sure if upstream forgot something, and if this count as bundling, but I think this should be clarified before approving.

Package Review
==============

Legend:
[x] = Pass, [!] = Fail, [-] = Not applicable, [?] = Not evaluated
[ ] = Manual review needed


Issues:
=======
- Package contains no bundled libraries without FPC exception.
  jquery is bundled in vendors/assets/javascripts
  and the resulting package bundle bootstrap as well :


- tests should be run

===== MUST items =====

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[x]: License field in the package spec file matches the actual license.
     Note: Checking patched sources after %prep for licenses. Licenses found:
     "Unknown or generated". 160 files have unknown license. Detailed output
     of licensecheck in /home/misc/checkout/git/FedoraReview/894524-rubygem-
     openshift-origin-console/licensecheck.txt
[x]: License file installed when any subpackage combination is installed.
[x]: Package must own all directories that it creates.
     Note: Directories without known owners: /usr/share/gems,
     /usr/share/gems/doc
[!]: Package contains no bundled libraries without FPC exception.
[x]: Changelog in prescribed format.
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
     Note: rm -rf %{buildroot} present but not required
[x]: Sources contain only permissible code or content.
[-]: Package contains desktop file if it is a GUI application.
[x]: Development files must be in a -devel package
[x]: Package uses nothing in %doc for runtime.
[x]: Package consistently uses macros (instead of hard-coded directory names).
[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
[x]: Package obeys FHS, except libexecdir and /usr/target.
[-]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[x]: Requires correct, justified where necessary.
[x]: Spec file is legible and written in American English.
[x]: Package contains systemd file(s) if in need.
[x]: Package is not known to require an ExcludeArch tag.
[x]: Package complies to the Packaging Guidelines
[x]: Package successfully compiles and builds into binary rpms on at least one
     supported primary architecture.
[x]: Package installs properly.
[x]: Rpmlint is run on all rpms the build produces.
     Note: No rpmlint messages.
[x]: If (and only if) the source package includes the text of the license(s)
     in its own file, then that file, containing the text of the license(s)
     for the package is included in %doc.
[x]: Package requires other packages for directories it uses.
[x]: Package does not own files or directories owned by other packages.
[x]: All build dependencies are listed in BuildRequires, except for any that
     are listed in the exceptions section of Packaging Guidelines.
[x]: Package uses either %{buildroot} or $RPM_BUILD_ROOT
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Package use %makeinstall only when make install' ' DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: Package do not use a name that already exist
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as provided
     in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.
[x]: Large documentation must go in a -doc subpackage. Large could be size
     (~1MB) or number of files.
     Note: Documentation size is 0 bytes in 0 files.
[x]: Packages must not store files under /srv, /opt or /usr/local

Ruby:
[x]: Platform dependent files must all go under %{gem_extdir_mri}, platform
     independent under %{gem_dir}.
[x]: Gem package must not define a non-gem subpackage
[x]: Macro %{gem_extdir} is deprecated.
[x]: Gem package is named rubygem-%{gem_name}
[x]: Package contains BuildRequires: rubygems-devel.
[x]: Gem package must define %{gem_name} macro.
[x]: Pure Ruby package must be built as noarch
[x]: Package does not contain Requires: ruby(abi).
[x]: Package contains Requires: ruby(release).

===== SHOULD items =====

Generic:
[x]: Avoid bundling fonts in non-fonts packages.
     Note: Package contains font files
[x]: If the source package does not include license text(s) as a separate file
     from upstream, the packager SHOULD query upstream to include it.
[x]: Final provides and requires are sane (see attachments).
[-]: Package functions as described.
[x]: Latest version is packaged.
[x]: Package does not include license text files separate from upstream.
[-]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[x]: Package should compile and build into binary rpms on all supported
     architectures.
[!]: %check is present and all tests pass.
[x]: Packages should try to preserve timestamps of original installed files.
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[x]: Sources can be downloaded from URI in Source: tag
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: Dist tag is present (not strictly required in GL).
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: Fully versioned dependency in subpackages if applicable.
[x]: SourceX is a working URL.
[x]: Spec use %global instead of %define unless justified.

Ruby:
[!]: Test suite of the library should be run.
[x]: Specfile should use macros from rubygem-devel package.
     Note: The specfile doesn't use these macros: %{gem_libdir}, %exclude
     %{gem_cache}, %{gem_spec}
[x]: Gem package should exclude cached Gem.
[x]: Gem should use %gem_install macro.

===== EXTRA items =====

Generic:
[x]: Rpmlint is run on all installed packages.
     Note: No rpmlint messages.
[x]: Spec file according to URL is the same as in SRPM.


Rpmlint
-------
Checking: rubygem-openshift-origin-console-1.13.0.1-1.fc19.noarch.rpm
          rubygem-openshift-origin-console-doc-1.13.0.1-1.fc19.noarch.rpm
          rubygem-openshift-origin-console-1.13.0.1-1.fc19.src.rpm
3 packages and 0 specfiles checked; 0 errors, 0 warnings.




Rpmlint (installed packages)
----------------------------
# rpmlint rubygem-openshift-origin-console-doc rubygem-openshift-origin-console
2 packages and 0 specfiles checked; 0 errors, 0 warnings.
# echo 'rpmlint-done:'



Requires
--------
rubygem-openshift-origin-console-doc (rpmlib, GLIBC filtered):
    /usr/bin/env
    rubygem-openshift-origin-console

rubygem-openshift-origin-console (rpmlib, GLIBC filtered):
    ruby(release)
    rubygem(sass-twitter-bootstrap)
    rubygems



Provides
--------
rubygem-openshift-origin-console-doc:
    rubygem-openshift-origin-console-doc

rubygem-openshift-origin-console:
    rubygem(openshift-origin-console)
    rubygem-openshift-origin-console



Source checksums
----------------
http://mirror.openshift.com/pub/openshift-origin/source/rubygem-openshift-origin-console/openshift-origin-console-1.13.0.1.gem :
  CHECKSUM(SHA256) this package     : f9fcb92a711435a8678b43d8ad6e825be0097b67a1e39ad3adf59840ac9d5c0f
  CHECKSUM(SHA256) upstream package : f9fcb92a711435a8678b43d8ad6e825be0097b67a1e39ad3adf59840ac9d5c0f


Generated by fedora-review 0.4.0 (cf29f98) last change: 2013-02-08
Command line :./try-fedora-review -b 894524
Buildroot used: fedora-19-x86_64
Active plugins: Generic, Ruby, Shell-api
Disabled plugins: Java, C/C++, Python, fonts, SugarActivity, Ocaml, Perl, Haskell, R, PHP
Disabled flags: EXARCH, EPEL5, BATCH, DISTTAG
Comment 14 Vít Ondruch 2013-10-21 04:31:15 EDT
I have two random points:

1) There are now web assets guidelines. Not sure how much they can apply to this package, neither how to apply them ;)

2) There are bundled fonts. Not sure if they should be treated as web assets or packaged as Fedora font.


[1] https://fedoraproject.org/wiki/Packaging:Web_Assets
Comment 15 Vít Ondruch 2013-10-21 04:33:20 EDT
Actually, the web assets guidelines [1] speaks clearly: "therefore alternative web font formats like WOFF are prohibited"

[1] https://fedoraproject.org/wiki/Packaging:Web_Assets#Fonts
Comment 16 Troy Dawson 2014-04-02 18:57:15 EDT
Spec URL: http://tdawson.fedorapeople.org/openshift-origin/rubygem-openshift-origin-console.spec
SRPM URL: http://tdawson.fedorapeople.org/openshift-origin/rubygem-openshift-origin-console-1.18.0.1-1.fc20.src.rpm

- Updated to latest stable release.

- The bundled javascripts are still there.  I will talk to the developers why, and if it will hurt for me to rip them out.

- The bundled fonts are still in the package.
-- This is not going to be an easy task.
-- The opensans font is not available for RHEL, so I will have to package it for EPEL before upstream will begin to fix the problem.
--- I will then talk to the upstream developers about removing eot and woff fonts and only using ttf.
-- I guess I will have to create an openshift font package.
Comment 17 Troy Dawson 2014-10-03 13:48:54 EDT
Closing Review Request.
The latest versions of this package is no longer supported on Fedora, and is not expected to be in the future.
Thank you for everyone's efforts in reviewing this package up to this point.